{
===============================================================================
  Copyright (©) 2007. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 
  Versión actual: 1.0.0
  Fecha versión actual: 
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
===============================================================================
}

unit uBizOscProducts;

interface

uses
  uDAInterfaces, uDADataTable, uDBSelectionListUtils, schTiendaWebClient_Intf;

const
  BIZ_CLIENT_OSC_PRODUCT = 'Client.OscProduct';

type
  IBizOscProduct = interface(Iosc_Products)
  	['{7D900965-99B4-45B1-8385-09C996819A1D}']    
    function EsNuevo : Boolean;
  end;

  TBizOscProduct = class(Tosc_ProductsDataTableRules, IBizOscProduct, ISeleccionable)
  protected
  	FSeleccionableInterface : ISeleccionable;

    procedure OnNewRecord(Sender: TDADataTable); override;
  public
    procedure IniciarValoresNuevo;
    function EsNuevo : Boolean;
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

    property SeleccionableInterface : ISeleccionable
    					read FSeleccionableInterface
    					write FSeleccionableInterface
    					implements ISeleccionable;
  end;

implementation

{ TBizOscProduct }

uses
  SysUtils, uDataTableUtils;

constructor TBizOscProduct.Create(aDataTable: TDADataTable);
begin
  inherited;
  
	FSeleccionableInterface := TSeleccionable.Create(aDataTable);  
end;

destructor TBizOscProduct.Destroy;
begin
  
  FSeleccionableInterface := NIL;
  inherited;
end;

function TBizOscProduct.EsNuevo: Boolean;
begin
  Result := (products_id < 0)
end;

procedure TBizOscProduct.IniciarValoresNuevo;
begin
  products_date_added := Now;
end;

procedure TBizOscProduct.OnNewRecord(Sender: TDADataTable);
begin
  inherited;
  products_id := GetRecNo; // -1, -2, -3...
  IniciarValoresNuevo;
end;

initialization
  RegisterDataTableRules(BIZ_CLIENT_OSC_PRODUCT, TBizOscProduct);

finalization

end.

